package com.fmi.weprom.api;

import java.util.List;

public interface AccessRights {
  
  public void grantUserRole(User user, Role r, Workspace w) throws WEPROMException;
  
  public void grantUserRoles(User user, List roles, Workspace w) throws WEPROMException;
  
  public void deleteUserRole(User user, Role r, Workspace w);
  
  public void deleteUserRoles(User user, List roles, Workspace w);
  
  public void deleteUserRoles(User user, Workspace w);
  
  public boolean checkPermission(User user, Workspace w, Permission p);
  
  public List getUserRoles(User user, Workspace w);
  
  public Permission getPermission(String name);
  
  public Role getRole(String name);
  
  public List getUsersWithoutRoles(Workspace w);

  public boolean checkPermission(User user, int workspaceID, Permission p);
}
