package com.fmi.weprom.api;


public abstract class Permission {
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // Permissions for USER Role
  /////////////////////////////////////////////////////////////////////////////////////////////////
  
  // UserWorkspace releated
  public static final String VIEW_CALENDAR = "calendar.view";
  public static final String VIEW_REMINDER = "reminder.view";
  public static final String CREATE_REMINDER = "reminder.create";
  public static final String DELETE_REMINDER = "reminder.delete";
  public static final String UPDATE_REMINDER = "reminder.update";
  
  public static final String CREATE_FOLDER= "folder.create";
  public static final String DELETE_FOLDER= "folder.delete";
  public static final String VIEW_FOLDER = "folder.view";
  public static final String CREATE_DOC = "document.create";
  public static final String DELETE_DOC = "document.delete";
  public static final String VIEW_DOC = "document.view";
  
  public static final String CREATE_CONTACT = "contact.create";
  public static final String UPDATE_CONTACT = "contact.update";
  public static final String VIEW_CONTACT = "contact.view";
  public static final String VIEW_CONTACTS = "contact.list.view";
  
  public static final String CREATE_MESSAGE = "message.create";
  
  public static final String VIEW_MY_WORKSPACE = "user.workspace.view";
  
  // Project related
  // TODO check if it is better to move them to another role, for example PROJECT_PARTICIPANT
  public static final String VIEW_PROJECT = "project.view";
  public static final String CREATE_PROJECT = "project.create";

  public static final String VIEW_PROJECT_FOLDER = "project.folder.view";
  public static final String CREATE_PROJECT_FOLDER= "project.folder.create";
  public static final String DELETE_PROJECT_FOLDER= "project.folder.delete";  
  public static final String CREATE_PROJECT_DOC = "project.document.create";
  public static final String DELETE_PROJECT_DOC = "project.document.delete";
  public static final String VIEW_PROJECT_DOC = "project.document.view";
  
  public static final String UPDATE_PROJECT_TASK = "project.task.update";
  //public static final String VIEW_TASK = "project.task.view"; // sashtoto kato dolnoto
  public static final String VIEW_PROJECT_TASK = "project.task.view"; 
  public static final String VIEW_PROJECT_TASKS = "project.tasks.view";
  //public static final String VIEW_TASKS = "project.tasks.view"; // this is the same as VIEW_PROJECT_TASKS
  
  public static final String VIEW_PROJECT_REMINDER = "project.reminder.view";
  
  public static final String VIEW_PROJECT_CALENDAR = "project.calendar.view";
  
  // Community related ones
  // TODO check if it is better to move them to another role, for example COMMUNITY_PARTICIPANT (without CREATE_COMMUNITY - it belongs to the USER role)
  public static final String VIEW_COMMUNITY = "community.read";  
  public static final String CREATE_COMMUNITY = "community.create";
  
  public static final String CREATE_COMMUNITY_FOLDER = "community.folder.create";
  public static final String DELETE_COMMUNITY_FOLDER = "community.folder.delete";
  public static final String VIEW_COMMUNITY_FOLDER = "community.folder.read";
  public static final String CREATE_COMMUNITY_DOC = "community.doc.create";
  public static final String DELETE_COMMUNITY_DOC = "community.doc.delete";
  public static final String VIEW_COMMUNITY_DOC = "community.doc.read";
  
  public static final String VIEW_COMMUNITY_CALENDAR = "community.calendar.read";
  public static final String VIEW_COMMUNITY_REMINDER = "community.reminder.read";
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // Permissions for PROJECT_COORDINATOR Role
  /////////////////////////////////////////////////////////////////////////////////////////////////
  public static final String DELETE_PROJECT = "project.delete";
  public static final String UPDATE_PROJECT = "project.update";
  
  //public static final String CREATE_PROJECT_USER = "project.user.create"; // ne e li po-dobre PROJECT_USER_INVITE
  //public static final String DELETE_PROJECT_USER = "project.user.delete"; // rename to remove? :)
  //public static final String UPDATE_PROJECT_USER = "project.user.update"; // tova pak kakvo e? :)
  //public static final String ASSIGN_ROLES = "project.user.role.assign"; // rename to ASSIGN_ROLE .. bez S :) ili oshte po-dobre PROJECT_USER_ASSIGN_ROLE
  public static final String PROJECT_USER_EDIT_ROLES = "project.user.roles.edit";
  
  public static final String CREATE_PROJECT_REMINDER = "project.reminder.create";
  public static final String DELETE_PROJECT_REMINDER = "project.reminder.delete";
  public static final String UPDATE_PROJECT_REMINDER = "project.reminder.update";
  
  public static final String CREATE_PROJECT_TASK = "project.task.create"; 
  public static final String DELETE_PROJECT_TASK = "project.task.delete"; 
  public static final String ASSIGN_TASKS = "project.task.assign";
  
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // Permissions for COMMUNITY_COORDINATOR Role
  /////////////////////////////////////////////////////////////////////////////////////////////////
  public static final String UPDATE_COMMUNITY = "community.update";
  public static final String DELETE_COMMUNITY = "community.delete";
  
  //public static final String CREATE_COMMUNITY_USER = "community.user.create"; // rename to COMMUNITY_USER_INVITE? ili COMMUNITY_USER_ASSIGN_ROLE
  //public static final String UPDATE_COMMUNITY_USER = "community.user.update";
  //public static final String DELETE_COMMUNITY_USER = "community.user.delete";
  //public static final String COMMUNITY_USER_ASSIGN_ROLE = "community.user.role.assign"; // tova go dobavih .. ima li sense?:)
  public static final String COMMUNITY_USER_EDIT_ROLES = "community.user.roles.edit";
  
  public static final String CREATE_COMMUNITY_REMINDER = "community.reminder.create";
  public static final String UPDATE_COMMUNITY_REMINDER = "community.reminder.update";
  public static final String DELETE_COMMUNITY_REMINDER = "community.reminder.delete";
  
  /*

Za PROJECT_COORDINATOR ima oshte 1 permisssion:

Permission.CREATE_PROJECT_MESSAGE
toi shte se polzva kato invite-vame users..., togava nali shte prashtame invitation message. 

ne stiga li CREATE_PROJECT_USER (PROJECT_USER_INVITE) .. tova avtomatichno shte prashta message


   */
  protected String name;
  protected int id;
  
  public Permission(int id, String name) {
    this.id = id;
    this.name = name;
  }

  public String getName() {
    return name;
  }
  
  public int getID() {
    return id;
  }
  
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Permission[");
    sb.append(id).append(',').append(name).append(']');
    return sb.toString();
  }  
  
  public abstract boolean implies(Permission permission);
  

}
