package com.fmi.weprom.api;

import java.util.Date;
import java.util.List;

public interface Project extends Workspace {
  
  // project statuses
  public static final int PROJECT_STATUS_NOTSTARTED = 0;
  public static final int PROJECT_STATUS_INPROCESS = 1;
  public static final int PROJECT_STATUS_WAITING = 2;
  public static final int PROJECT_STATUS_COMPLETED = 3;  
  
  public Calendar getCalendar();
  
  public Task createTask(User owner);
  
  public List getTasks();
  
  public Task getTask(int id);
  
  public void save() throws WEPROMException;
  
  public void update() throws WEPROMException;
  
  public void delete() throws WEPROMException;
  
  public String getName();
  
  public void setName(String name) ;
  
  public Date getStartDate();
  
  public Date getEndDate();
  
  public String getDescription();
  
  public int getCompleted();
  
  public int getStatus();
  
  public void setStartDate(Date startDate);
  
  public void setEndDate(Date endDate);
  
  public void setDescription(String  description);
  
  public void setCompleted(int completed);
  
  public void setStatus(int status);  
  
  public void inviteUser(User user) throws WEPROMException;
}
