package com.fmi.weprom.api;

import java.util.List;


public abstract class Role {
  
  public static final String ADMINISTRATOR = "Administrator";
  public static final String PROJECT_COORDINATOR = "ProjectCoordinator";
  public static final String COMMUNITY_COORDINATOR = "CommunityCoordinator";
  public static final String USER = "User";
  public static final String GUEST = "Guest";
  public static final String PROJECT_PARTICIPANT = "ProjectParticipant";
  public static final String COMMUNITY_PARTICIPANT = "CommunityParticipant";
  
  protected String name;
  protected int id;
    
  
  public Role(int id, String name) {
    this.id = id;
    this.name = name;
  }

  public String getName() {
    return name;
  }
  
  public int getID() {
    return id;
  }
  
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Role[");
    sb.append(id).append(',').append(name).append(']');
    return sb.toString();
  }
  
  public abstract List getPermissions();
  
  public int hashCode() {
    return name.hashCode();
  }
  
  public boolean equals(Object anObject) {
   if (this == anObject) 
       return true;
   
   if (anObject instanceof Role) {
     Role r = (Role)anObject;
      return r.name.equals(name);
    }
    return false;
  }
}
