package com.fmi.weprom.api;


import java.util.Date;
import java.util.List;

public interface Task {
  // task statuses
  public static final int TASK_STATUS_NOTSTARTED = 0;
  public static final int TASK_STATUS_INPROCESS = 1;
  public static final int TASK_STATUS_WAITING = 2;
  public static final int TASK_STATUS_COMPLETED = 3;

  // task priorities
  public static final int TASK_PRIORITY_LOW = 0;
  public static final int TASK_PRIORITY_MEDIUM = 1;
  public static final int TASK_PRIORITY_HIGH = 2;
  public static final int TASK_PRIORITY_VERYHIGH = 3;
  
  public int getID();
  
  public void setProcessor(User processor);
  
  public User getProcessor();
  
  public void save() throws WEPROMException;
  
  public void delete() throws WEPROMException;
  
  public void update() throws WEPROMException;
  
  public int getCompleted();

  public void setCompleted(int completed);

  public String getDescription();

  public void setDescription(String description);

  public Date getEndDate();

  public void setEndDate(Date end_date);

  public int getPriority();

  public void setPriority(int priority);

  public Date getStartDate();

  public void setStartDate(Date start_date);

  public int getStatus();

  public void setStatus(int status);

  public String getSubject();

  public void setSubject(String subject);

  public User getOwner();

  public Project getProject();  
  
  public void setAssigned(boolean assigned);
  
  public boolean isAssigned();
  
}
