package com.fmi.weprom.impl.mysql;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Date;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.fmi.weprom.api.Calendar;
import com.fmi.weprom.api.Reminder;
import static com.fmi.weprom.impl.mysql.WEPROMSystemImpl.*;

public class CalendarImpl implements Calendar {

  private static final Log LOG = LogFactory.getLog(CalendarImpl.class);
  
  //transient WorkspaceImpl workspace;  
  int workspace_id;
  int workspace_type;
  
  
  CalendarImpl(WorkspaceImpl workspace) {
    this.workspace_id = workspace.getID();
    this.workspace_type = workspace.getType(); 
  }
  
  public Reminder createReminder() {
    return new ReminderImpl(this);
  }

  public List getReminders() {
    LOG.debug("getReminders()");
    List result = ReminderImpl.loadReminders(this);
    return result;
  }

  public Reminder getReminder(int remId) {
    LOG.debug("getReminder( "+remId +" )");
    return ReminderImpl.getInstance(this, remId);
  }

  public int getWorkspaceID() {
    return workspace_id;
  }
  /*
  public WorkspaceImpl getWorkspace() {
    WorkspaceImpl workspace = null;
    switch (workspace_type) {    
      case MASTER_TYPE_USERWORKSPACE:
        
        break;
        
      case MASTER_TYPE_PROJECT:
        
          break;
    }
    return workspace;
  }
*/
  public List getReminders(Date startDate, Date endDate) {
    LOG.debug("getReminders(FROM ["+startDate+"] TO ["+endDate+"])");
    List result = ReminderImpl.loadReminders(this, startDate, endDate);
    return result;
  }
  
  private void writeObject(ObjectOutputStream oos) throws IOException {
    oos.defaultWriteObject();    
    LOG.debug("SERIALIZE: " + toString());    
  }
  
  private void readObject(ObjectInputStream ois) throws ClassNotFoundException, IOException {
    ois.defaultReadObject();    
    LOG.debug("DESERIALIZE: " + toString());    
  }  
}
