package com.fmi.weprom.impl.mysql;

import java.io.IOException;
import java.text.DateFormat;
import java.util.Date;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.fmi.weprom.util.WepromRequestCycleUtil;

public class RequestFilter implements Filter {

  private static final Log LOG = LogFactory.getLog(RequestFilter.class);
  private static final DateFormat dateFormat = DateFormat.getDateTimeInstance(DateFormat.SHORT, DateFormat.MEDIUM);
  public void init(FilterConfig arg0) throws ServletException  {
    // TODO Auto-generated method stub
    
  }

  public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
    String host = request.getRemoteHost();
    String threadName = Thread.currentThread().getName();
    String prefix = "====== [" + threadName + "] ";
    String date = dateFormat.format(new Date());
    //System.out.println("========================================================================================");
    System.out.println(prefix+"===============BEGIN===========["+date+"]====["+host+"]==========");    
    //WepromRequestCycleUtil.open();
    
    long start = System.currentTimeMillis();
    // call tapestry servlet
    chain.doFilter(request, response);
    long end = System.currentTimeMillis();
    
    //Session.closeSession();
    //WepromRequestCycleUtil.close();
    System.out.println(prefix+"===============END=============["+(end-start)+" ms]============================================");
  }

  public void destroy() {
    // TODO Auto-generated method stub
    
  }

}
/*

Da se dobavi v web.xml :

  <filter> 
    <filter-name>mysql_session</filter-name>
    <filter-class>com.fmi.weprom.impl.mysql.RequestFilter</filter-class>
  </filter>
  
  <filter> 
    <filter-name>redirect</filter-name>
    <filter-class>org.apache.tapestry.RedirectFilter</filter-class>
  </filter>

  <filter-mapping>
    <filter-name>redirect</filter-name>
    <url-pattern>/</url-pattern>
  </filter-mapping> 
  
  <filter-mapping>
    <filter-name>mysql_session</filter-name>
    <servlet-name>eprom2.2</servlet-name>
  </filter-mapping>   
*/