package workspace.web;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Date;
import java.util.GregorianCalendar;
import java.io.Serializable;

public class DateComparator implements Comparator, Serializable{
	// The format of the date is: dd.MM.yyyy kk:mm 
	public int compare(Object o1, Object o2)
	{
		// return -1 if o1 < o2; return 0 if o1 == o2; return 1 if o1 > o2
		String day1 = "01";
		String month1 = "01";
		String year1 = "1900";
		String hour1 = "01";
		String minutes1 = "01";
		if (o1 instanceof String) {
			String messageDate1 = (String) o1 ;
			day1 = messageDate1.substring(0,2);
			month1 = messageDate1.substring(3,5);
			year1 = messageDate1.substring(6,10);
			hour1 = messageDate1.substring(11,13);
			minutes1 = messageDate1.substring(14,16);
		}

		String day2 = "01";
		String month2 = "01";
		String year2 = "1900";
		String hour2 = "01";
		String minutes2 = "01";
		if (o2 instanceof String) {
			String messageDate2 = (String) o2 ;
			day2 = messageDate2.substring(0,2);
			month2 = messageDate2.substring(3,5);
			year2 = messageDate2.substring(6,10);
			hour2 = messageDate2.substring(11,13);
			minutes2 = messageDate2.substring(14,16);
		}
		
		int yearCompare = year1.compareTo(year2);
		if(yearCompare !=0) {
			return yearCompare;
		} else {
			int monthCompare = month1.compareTo(month2);
			if(monthCompare !=0) {
				return monthCompare;
			} else {
				int dayCompare = day1.compareTo(day2);
				if(dayCompare !=0) {
					return dayCompare;
				} else {
					int hourCompare = hour1.compareTo(hour2);
					if(hourCompare !=0) {
						return hourCompare;
					} else
						return minutes1.compareTo(minutes2);
				}
			}
		}		
	}
	public static final boolean isDateInPeriod(Date dateToCheck, Date startDate, Date endDate){
		GregorianCalendar dt = createGregCalendarForDate(dateToCheck);
		GregorianCalendar strtDt = createGregCalendarForDate(startDate);
		GregorianCalendar endDt = createGregCalendarForDate(endDate);
		if (dt.get(Calendar.YEAR)>=strtDt.get(Calendar.YEAR)&
			dt.get(Calendar.DAY_OF_YEAR)>=strtDt.get(Calendar.DAY_OF_YEAR)&
			dt.get(Calendar.YEAR)<=endDt.get(Calendar.YEAR)&
			dt.get(Calendar.DAY_OF_YEAR)<=endDt.get(Calendar.DAY_OF_YEAR)) 
			return true;
		else 
			return false;
	}
	public static final boolean areDatesEqual(Date date1, Date date2){
		GregorianCalendar dt1 = createGregCalendarForDate(date1);
		GregorianCalendar dt2 = createGregCalendarForDate(date2);
		if (dt1.get(Calendar.YEAR)==dt2.get(Calendar.YEAR)&
				dt1.get(Calendar.DAY_OF_YEAR)==dt2.get(Calendar.DAY_OF_YEAR))
			return true;
		else 
			return false;
	}
	public static final GregorianCalendar createGregCalendarForDate(Date date){
		SimpleDateFormat formatterDay = new SimpleDateFormat("dd");        
		SimpleDateFormat formatterMonth = new SimpleDateFormat("MM");        
		SimpleDateFormat formatterYear = new SimpleDateFormat("yyyy");        
		
		Calendar gregCalendar = new GregorianCalendar(
				Integer.parseInt(formatterYear.format(date)), 
				Integer.parseInt(formatterMonth.format(date))-1, 
				Integer.parseInt(formatterDay.format(date)));
		return (GregorianCalendar)gregCalendar;
	}
	public static final Date setTimeToDate(String time, Date date){
		String[] hourMin = time.split(":");
		int hour=Integer.parseInt(hourMin[0]);
		int min=Integer.parseInt(hourMin[1]);
		
		GregorianCalendar dt = createGregCalendarForDate(date);
		dt.set(Calendar.HOUR_OF_DAY, hour);
		dt.set(Calendar.MINUTE, min);
		SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yy hh:mm");        
		
        System.out.println(" Time is set to" + formatter.format(dt.getTime()));
		return dt.getTime();		
	}
}
