package workspace.web;

import java.io.Serializable;
import java.util.List;
import java.util.ArrayList;

import org.apache.tapestry.form.IPropertySelectionModel;

import com.fmi.weprom.api.Project;
import com.fmi.weprom.api.Task;

public class PrioritySelectionModel implements Serializable,
    IPropertySelectionModel {

  public static final String PRIORITY_LOW = "Low";
  public static final String PRIORITY_MEDIUM = "Medium";
  public static final String PRIORITY_HIGH = "High";
  public static final String PRIORITY_VERYHIGH = "Very high";

  private List statusList;
  private List displayList;
  
  public PrioritySelectionModel(){
    this.statusList = new ArrayList();
    this.displayList = new ArrayList();
    
    statusList.add(0, Task.TASK_PRIORITY_LOW);
    statusList.add(1, Task.TASK_PRIORITY_MEDIUM);
    statusList.add(2, Task.TASK_PRIORITY_HIGH);
    statusList.add(3, Task.TASK_PRIORITY_VERYHIGH);
    
    displayList.add(0, PRIORITY_LOW);
    displayList.add(1, PRIORITY_MEDIUM);
    displayList.add(2, PRIORITY_HIGH);
    displayList.add(3, PRIORITY_VERYHIGH);  
  }
  
  public int getOptionCount() {
    return statusList.size();
  }

  public Object getOption(int index) {
    return statusList.get(index);
  }

  public String getLabel(int index) {
    return (String)displayList.get(index);
  }

  public String getValue(int index) {
    return index + "";
  }

  public Object translateValue(String value) {
    return getOption(Integer.parseInt(value));          
  }
  public String getPriorityDisplay(int priority){
    for(int i = 0; i < statusList.size(); i++)
      if(((Integer)statusList.get(i)).intValue() == priority)
        return (String)displayList.get(i);
    return "";
  }
}
