package workspace.web;

import java.io.Serializable;
import java.util.List;
import java.util.ArrayList;

import org.apache.tapestry.form.IPropertySelectionModel;

import com.fmi.weprom.api.Project;
import com.fmi.weprom.api.Task;

public class StatusSelectionModel implements Serializable,
    IPropertySelectionModel {

  public static final int PROJECT = 1;
  public static final int TASK = 2;

  public static final String STATUS_NOTSTARTED = "Not started";
  public static final String STATUS_INPROCESS = "In process";
  public static final String STATUS_WAITING = "Waiting";
  public static final String STATUS_COMPLETED = "Completed";

  private List statusList;
  private List displayList;
  int type;
  
  public StatusSelectionModel(int type){
    this.type = type;
    this.statusList = new ArrayList();
    this.displayList = new ArrayList();
    if(type == PROJECT){
      statusList.add(0, Project.PROJECT_STATUS_NOTSTARTED);
      statusList.add(1, Project.PROJECT_STATUS_INPROCESS);
      statusList.add(2, Project.PROJECT_STATUS_WAITING);
      statusList.add(3, Project.PROJECT_STATUS_COMPLETED);      
    } else {
      statusList.add(0, Task.TASK_STATUS_NOTSTARTED);
      statusList.add(1, Task.TASK_STATUS_INPROCESS);
      statusList.add(2, Task.TASK_STATUS_WAITING);
      statusList.add(3, Task.TASK_STATUS_COMPLETED);
    }
    displayList.add(0, STATUS_NOTSTARTED);
    displayList.add(1, STATUS_INPROCESS);
    displayList.add(2, STATUS_WAITING);
    displayList.add(3, STATUS_COMPLETED);  
  }
  
  public int getOptionCount() {
    return statusList.size();
  }

  public Object getOption(int index) {
    return statusList.get(index);
  }

  public String getLabel(int index) {
    return (String)displayList.get(index);
  }

  public String getValue(int index) {
    return index + "";
  }

  public Object translateValue(String value) {
    return getOption(Integer.parseInt(value));          
  }
  
  public String getStatDisplay(int status){
    for(int i = 0; i < statusList.size(); i++)
      if(((Integer)statusList.get(i)).intValue() == status)
        return (String)displayList.get(i);
    return "";
  }
}
