package workspace.web;

import java.io.Serializable;
import java.util.List;

import org.apache.tapestry.form.IPropertySelectionModel;

import com.fmi.weprom.api.Project;
import com.fmi.weprom.api.Community;

public class WorkspaceSelectionModel implements Serializable,
    IPropertySelectionModel {
  public static final int PROJECT = 2;
  public static final int COMMUNITY = 3;
  private List workspaceList;
  private int type;
  
  public WorkspaceSelectionModel(List workspaceList){
    this.workspaceList = workspaceList;
  }
  
  public WorkspaceSelectionModel(List workspaceList, int type){
    this.workspaceList = workspaceList;
    this.type = type;
  }
  
  public int getOptionCount() {
    return workspaceList.size() + 1;
  }

  public Object getOption(int index) {
    if(index == 0)
      return null;
    else
      return workspaceList.get(index-1);
  }

  public String getLabel(int index) {
    if(index == 0)
      return "Not Specified";
    else if (type == PROJECT)
        return ((Project) workspaceList.get(index-1)).getName();
      else if (type == COMMUNITY)        
        return ((Community) workspaceList.get(index-1)).getName();
      else
        return "Workspace " + (index-1);    
  }

  public String getValue(int index) {
    return index + "";
  }

  public Object translateValue(String value) {
    if(Integer.parseInt(value)<=workspaceList.size())
      return getOption(Integer.parseInt(value));       
    else
      return workspaceList.get(0);
  }
  
  public void setWorkspaceList(List workspaceListVal){
    this.workspaceList = workspaceListVal;
  }
  
  public List getWorkspaceList(){
    return this.workspaceList;
  }
}
