package workspace.web.components;

import org.apache.tapestry.BaseComponent;
import org.apache.tapestry.IPage;

import workspace.Visit;
import com.fmi.weprom.api.Project;
import com.fmi.weprom.api.Community;

public abstract class Border extends BaseComponent {
  private String _pageDispName;

  public String getPageDispName() {
    IPage page = getPage();
    String pageName = page.getPageName();
    _pageDispName = page.getSpecification().getProperty("page-disp-name");
    if (_pageDispName == null)
      _pageDispName = pageName;
    return _pageDispName;
  }

  public boolean getIsLogIn() {
    Visit visit = (Visit) getPage().getVisit();
    return visit.isUserLoggedIn();
  }

  public String getTitleUser() {
    if (getIsLogIn()) {
      Visit visit = (Visit) getPage().getVisit();
      String userId = visit.getUserId();
      return "Welcome " + userId;
    } else
      return "Welcome Guest";
  }

  public String getWorkspaceName() {
    if (getIsLogIn()) {
      Visit visit = (Visit) getPage().getVisit();
      Project project = visit.getProject();
      if (project != null){
        String projectName = project.getName();
        return "Project " + projectName;
      } else {
        Community community = visit.getCommunity();
        if (community != null){
          String communityName = community.getName();
          return "Community " + communityName;
        }
        return "My workspace";
      }
    } else
      return "Public Space";
  }
}
