package workspace.web.components.docsbrowser;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.nordija.tapestry.bayeux.downloads.DownloadResource;

public class DocsDownloadResource implements DownloadResource {
  
  private static final Log LOG = LogFactory.getLog(DocsDownloadResource.class);
  private static final String CATALINA_HOME = "catalina.home";
  private static final String DOCUMENTS_FOLDER = "webapps/weprom/docs/";
  private int fileID;
  String fileName;
  
  DocsDownloadResource(int fileID, String fileName) {
    this.fileID = fileID;
    this.fileName = fileName;
  }
  
  public InputStream getInputStream() throws IOException {
    LOG.debug("getInputStream()");
    String path = getRootDocumentsFolder()+java.io.File.separatorChar+fileID;//"LanguageGuide.pdf";
    java.io.File file = new java.io.File(path);
    if (file.exists()) {
      return new FileInputStream(path);
    } else {
      return null;
      /*new FileInputStream(getRootDocumentsFolder()+java.io.File.separatorChar+"LanguageGuide.pdf");*/
    }
  }
  
  private static String getRootDocumentsFolder() {
    String catalinaHome = System.getProperty(CATALINA_HOME);
    StringBuilder sb = new StringBuilder();
    
    if (catalinaHome!=null) {
      sb.append(catalinaHome);
      sb.append(java.io.File.separatorChar);
    }
    sb.append(DOCUMENTS_FOLDER);
    
    return sb.toString();
  }

  public String getContentType() {
    LOG.debug("getContentType()");
    return "application/octet-stream";
  }
  
  public String getContentDisposition() {
    return fileName;
  }

}
