package workspace.web.components.docsbrowser;

import org.apache.tapestry.IMarkupWriter;
import org.apache.tapestry.IRender;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.contrib.tree.model.ITreeModelSource;

public class NodeRender implements IRender {

  FileNode node; 
  ITreeModelSource treeModelSource;
  Object nodeKey;
  
  
  public NodeRender(FileNode node, Object nodeKey, ITreeModelSource treeModelSource) {
    this.node = node;
    this.nodeKey = nodeKey;
    this.treeModelSource = treeModelSource;
  }
  
  public void render(IMarkupWriter writer, IRequestCycle cycle) {
    if (isSelected()) {
      writer.begin("B");
      writer.print(node.getName());
      writer.end();
    } else {
      writer.print(node.getName());
    }
    /*
    PrivateAsset objAsset = getAsset();
    writer.begin("img");
    writer.attribute("border", "0");
    writer.attribute("src", objAsset.buildURL(objCycle));
    writer.attribute("align", "bottom");
    writer.end();
    writer.print(" ");
    writer.begin("span");
    String strClassName = "fsNodeValue";
    writer.attribute("class", strClassName);
    writer.closeTag();
    writer.print(node.toString().trim());
    writer.end();  
    */
  }

  boolean isOpen() {
    return treeModelSource.getTreeModel().getTreeStateModel().isUniqueKeyExpanded(nodeKey);
  }

  boolean isSelected(){
    return nodeKey.equals(treeModelSource.getTreeModel().getTreeStateModel().getSelectedNode());
  }
}
