package workspace.web.pages;

import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.event.PageRenderListener;
import org.apache.tapestry.html.BasePage;

import workspace.Visit;

import com.fmi.weprom.api.Contact;

public abstract class ContactCreatorPage extends WEPROMBasePage implements PageRenderListener {
    public abstract Contact getContact();
    public abstract void setContact(Contact contact);
    public abstract int getMode();
    public abstract void setMode(int mode);
	public abstract void setPageType(String pageType);
	
    public void pageBeginRender(PageEvent event) {    
		System.out.println("ContactCreatorPage() ... isRewinding=" + event.getRequestCycle().isRewinding());
		setPageType(determinPageType());
		if(!event.getRequestCycle().isRewinding()){
			Contact contact = getContact();
			int mode = getMode();
	    	System.out.println("Contact: Mode = "+mode );
			//If the page is rendering in create mode and the contact is null,
			// create a new contact			
			if (contact==null & mode==0) {
				contact = ((Visit) getPage().getVisit()).getUserWorkspace().createContact();
				setContact(contact);
				setMode(2);
		    	System.out.println("contact subject: Mode = "+mode );
			}
		}
    	System.out.println("ContactCreatorPage: contactId = "+((Contact)getContact()).getID() );
    }
	private String determinPageType(){
		if (((Visit) getPage().getVisit()).getProject()==null)
			return"MyWorkspace";
		else
			return "Projects";
	}
}
