package workspace.web.pages;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.tapestry.annotations.Persist;
import org.apache.tapestry.event.PageEvent;

import workspace.Visit;
import workspace.web.components.docsbrowser.DocsBrowser;
import workspace.web.components.docsbrowser.DocsTableModel;

import com.fmi.weprom.api.File;
import com.fmi.weprom.api.Workspace;


public abstract class DocsBrowserPage extends WEPROMBasePage {
  
  private static final Log LOG = LogFactory.getLog(DocsBrowserPage.class);
  
  public abstract void setPageType(String pageType);
  
  @Persist
  public abstract Integer getRootID();
  public abstract void setRootID(Integer id);
  
  public File getRoot() {
    Visit visit = (Visit) getVisit();
    return visit.getWeprom().getFile(getRootID());      
  }
  
  private Workspace getCurrentWorkspace() {
    Workspace w = null;
    Visit visit = (Visit) getVisit();
    if (
        ((w=visit.getProject())!=null) ||
        ((w=visit.getCommunity())!=null) ||
        ((w=visit.getUserWorkspace())!=null)
        )
    {
      return w;
    }
    return null;
  }

  public void pageBeginRender(PageEvent event){
    setPageType(determinPageType());
    
    String _method = "pageBeginRender() "; 
    LOG.debug(_method);
    Integer oldRootID = getRootID();
    Visit visit = (Visit) getVisit();
    int newRootID = getCurrentWorkspace().getID();
    setRootID(newRootID);
    LOG.debug(_method+"oldRootID:" + oldRootID+" newRootID: "+newRootID);
    if (oldRootID!=null && (oldRootID.intValue()!=newRootID)) {
      // reset
      LOG.debug(_method+">>>>>>>>>> RESET");
      DocsBrowser docsBrowser = (DocsBrowser) getComponent("docsBrowser");
      if (docsBrowser!=null) {
        // reset tree
        docsBrowser.getDocsTreeModel().getTreeStateModel().resetState();
        
        // reset table
        ((DocsTableModel) docsBrowser.getTableModel()).setSelectedFolder(null);
      }      
    }    
  }
  
  private String determinPageType(){
    if (((Visit) getPage().getVisit()).getProject()!=null)
      return "Projects";
    else if (((Visit) getPage().getVisit()).getCommunity()!=null)
      return"Communities";
    else
      return "MyWorkspace";
  }
  
}
