package workspace.web.pages;

import org.apache.tapestry.html.BasePage;
import org.apache.tapestry.IRequestCycle;

import workspace.Visit;

public abstract class LoginPage extends BasePage {
  public abstract String getUserName();

  public abstract String getPassword();

  public abstract void setMessage(String message);

  public void finishLoad() {
    Visit visit = (Visit) getPage().getVisit();
    visit.clearSessionCache();
  }

  public void login(IRequestCycle cycle) {
    if (isValidLogin(getUserName(), getPassword())) {
      MyWorkspacePage myWorkspacePage = (MyWorkspacePage) cycle
          .getPage("MyWorkspacePage");
      cycle.activate(myWorkspacePage);
      return;
    }
    setMessage("Invalid user name or password.");
  }

  private boolean isValidLogin(String userName, String password) {
    Visit visit = (Visit) getPage().getVisit();
    return visit.login(userName, password);
  }
}
