package workspace.web.pages;

import java.util.List;
import java.util.ArrayList;

import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.event.PageRenderListener;
import org.apache.tapestry.html.BasePage;

import com.fmi.weprom.api.Message;
import workspace.Visit;
import workspace.MessageUtil;
import workspace.web.components.MessageEditor;

public abstract class MessageEditorPage extends WEPROMBasePage implements
    PageRenderListener {

  public abstract Message getMessage();
  public abstract void setMessage(Message message);

  public abstract int getMode();
  public abstract void setMode(int mode);

  public abstract String getReceiverString();
  public abstract void setReceiverString(String receiverString);

  public abstract void setPageType(String pageType);

  public abstract List getReceiverList();
  public abstract void setReceiverList(List receiverList);

  public void pageBeginRender(PageEvent event) {
    System.out.println("MessageEditorPage() ... isRewinding="
        + event.getRequestCycle().isRewinding());
    setPageType(determinPageType());
    if (!event.getRequestCycle().isRewinding()) {
      Message message = getMessage();
      int mode = getMode();
      System.out.println("Message: Mode = " + mode);
      if (message == null & mode != 0) {
        message = MessageUtil.createMessage(((Visit) getVisit()).getUser(), Message.MESSAGE_TYPE_TEXT);
        setReceiverString("");
        setMessage(message);
        MessageEditor messageEditor = (MessageEditor)getComponent("messageEditor");
        messageEditor.setWorkspaceTypeFilter(null);
      }
      if (message != null) {
        System.out.println("Message " + message);
        if(getReceiverString() == null || getReceiverString() == "")
          if (message.getReceiver() != null)
            setReceiverString(message.getReceiver().getLastName() + " " +
                message.getReceiver().getName()+ 
                " [ "+ message.getReceiver().getNick() + " ]");
          else
            setReceiverString("");
        System.out.println("Message receiver: " + getReceiverString());
      }
      List receiverList = getReceiverList();
      if (message != null & receiverList == null) {
        receiverList = new ArrayList();
        receiverList.add(getMessage().getReceiver());
      }
      setReceiverList(receiverList);
    }
  }

  private String determinPageType() {
    if (((Visit) getPage().getVisit()).getProject() == null)
      return "MyWorkspace";
    else
      return "Projects";
  }

}
