package workspace.web.pages;

import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.event.PageRenderListener;
import org.apache.tapestry.html.BasePage;

import workspace.Visit;

import com.fmi.weprom.api.Project;
import com.fmi.weprom.api.WEPROMException;

public abstract class ProjectCreatorPage extends WEPROMBasePage implements
    PageRenderListener {

  public abstract Project getProject();
  public abstract void setProject(Project project);
  public abstract int getMode();
  public abstract void setMode(int mode);
  public abstract void setPageType(String pageType);

  public void pageBeginRender(PageEvent event) {
    System.out.println("ProjectCreatorPage() ... isRewinding="
        + event.getRequestCycle().isRewinding());
    setPageType(determinPageType());
    Project project = getProject();
    if (project == null & getMode() == 0) {
      project = ((Visit) getPage().getVisit()).getWeprom().
            createProject(((Visit) getPage().getVisit()).getUser());
      setProject(project);
      setMode(2);
    }
  }

  private String determinPageType() {
    if (((Visit) getPage().getVisit()).getProject() == null)
      return "MyWorkspace";
    else
      return "Projects";
  }
}
