package workspace.web.pages;

import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.event.PageRenderListener;
import org.apache.tapestry.html.BasePage;

import workspace.Visit;

import com.fmi.weprom.api.Project;
import com.fmi.weprom.api.Task;
import com.fmi.weprom.api.User;

public abstract class TaskEditorPage extends WEPROMBasePage implements PageRenderListener{

    public abstract Task getTask();
    public abstract void setTask(Task task);
    public abstract int getMode();
    public abstract void setMode(int mode);
	public abstract void setPageType(String pageType);
    
	public void pageBeginRender(PageEvent event) {    
		System.out.println("TaskEditorPage() ... isRewinding=" + event.getRequestCycle().isRewinding());
		setPageType(determinPageType());
		if(!event.getRequestCycle().isRewinding()){
			Task task = getTask();
			int mode = getMode();
	    	System.out.println("Task: Mode = " + mode );
			if (task==null & mode!=0) {				
				task = getVisitO().getProject().createTask(getVisitO().getUser());				
				setTask(task);				
			}
		}
	}
	private String determinPageType(){
		if (getProject()==null)
			return"MyWorkspace";
		else
			return "Projects";
	}
	
	public Visit getVisitO() {
		return (Visit) getVisit();
	}

	public Project getProject() {
	    return (Project) getVisitO().getProject();
	}
}
