package workspace.web.pages;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.tapestry.PageRedirectException;
import org.apache.tapestry.annotations.InjectStateFlag;
import org.apache.tapestry.event.PageBeginRenderListener;
import org.apache.tapestry.event.PageDetachListener;
import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.event.PageRenderListener;
import org.apache.tapestry.event.PageValidateListener;
import org.apache.tapestry.html.BasePage;

import workspace.Visit;

import com.fmi.weprom.api.User;
import com.fmi.weprom.util.WepromRequestCycleUtil;

public abstract class WEPROMBasePage extends BasePage implements
    PageValidateListener, PageBeginRenderListener {//, PageDetachListener {

  @InjectStateFlag("visit")
  public abstract boolean getVisitExists();
  
  private static final Log LOG = LogFactory.getLog(WEPROMBasePage.class);
  
  public void pageValidate(PageEvent event) {
    User user = WepromRequestCycleUtil.currentUser();
    if (user == null) {
      Visit visit = (Visit) getPage().getVisit();
      if (visit.isUserLoggedIn()) {
        user = visit.getUser(); 
        
        // attach the current user to this thread
        WepromRequestCycleUtil.setUser(user);
        // attach the current shared session data to this thread
        WepromRequestCycleUtil.setSharedSessionData(visit.getSharedSessionData());
        return;
      } else {
        // no logged in user, so redirect him/her to the login page :)
        LoginPage login = (LoginPage) getRequestCycle().getPage("LoginPage");
        // login.setCallback(new PageCallback(this)); // should be uncomented if
        // need to remember the current page
        throw new PageRedirectException(login);
      }
    }
  }

  // we should not have sql transaction during the rendering!  
  public void pageBeginRender(PageEvent event) {
    //LOG.debug("pageBeginRender()");
    if (!event.getRequestCycle().isRewinding()) {      
      WepromRequestCycleUtil.beginRender();
    }
  }
/*
  public void pageEndRender(PageEvent event) {
    LOG.debug("pageEndRender()");
  }

  public void pageDetached(PageEvent event) {
    LOG.debug("pageDetached()");
    boolean visitExists = getVisitExists();
    System.out.println(">>>>>>>>>>>>>>>>>>>>>>> @InjectStateFlag(\"visit\")  : " + visitExists);
    if (visitExists) {
      Visit visit = (Visit) getVisit();
      Object ssData = WepromRequestCycleUtil.currentSharedSessionData();
      visit.setSharedSessionData(ssData);
    }
  }
  */
}
