package com.fmi.weprom.api;

import java.util.Date;
import java.util.List;

public interface Message {
  
  public static final int MESSAGE_TYPE_TEXT = 0;
  public static final int MESSAGE_TYPE_PROJECT_INVITATION = 1;
  public static final int MESSAGE_TYPE_COMMUNITY_INVITATION = 2;
  public static final int MESSAGE_TYPE_TASK_ASSIGNMENT = 3;
  //public static final int MESSAGE_TYPE_FOLDER_INVITATION = 4;
  
  public int getID();
  
  public void accept() throws WEPROMException;
  
  public void decline() throws WEPROMException;
  
  public void send() throws WEPROMException;
  
  public void delete() throws WEPROMException;
  
  public void update() throws WEPROMException;
  
  public String getSubject();

  public void setSubject(String subject);

  public String getBody();

  public void setBody(String text);

  public int getType();
  
  public void setType(int type);
  
  public Date getDate();

  public void setReceiver(User receiver);

  public void setSender(User sender);
  
  public User getSender();
  
  public User getReceiver();

  public boolean isNew();
  
  public void setNew(boolean b);

  public boolean isForwarded();
  
  public void setForwarded(boolean b);
  
  public boolean isReplied();
  
  public void setReplied(boolean b);
    
}
/*

task.asignUser() {
  sent message MESSAGE_TYPE_TASK_ASSIGNMENT
}

----
msg.accept() {

}

*/