package com.fmi.weprom.util;

import java.io.IOException;
import java.text.DateFormat;
import java.util.Date;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.tapestry.engine.state.ApplicationStateManager;
import org.apache.tapestry.services.WebRequestServicer;
import org.apache.tapestry.services.WebRequestServicerFilter;
import org.apache.tapestry.web.WebRequest;
import org.apache.tapestry.web.WebResponse;
import org.apache.tapestry.web.WebSession;

import com.fmi.weprom.impl.mysql.RequestFilter;

import workspace.Visit;

public class WepromRequestFilter implements WebRequestServicerFilter {
  
  private static final Log LOG = LogFactory.getLog(WepromRequestFilter.class);
  static final String VISIT_KEY = "visit";
  private ApplicationStateManager appStateManager;
  
  
  public void service(WebRequest request, WebResponse response, WebRequestServicer servicer) throws IOException {
    String serviceName = request.getParameterValue("service");
    String path = "";
    if ("asset".equals(serviceName)) {
      path = " path: "+request.getParameterValue("path");      
    }
    LOG.debug("BEGIN service: " + serviceName+path);
    
    WepromRequestCycleUtil.open();
    
    // Tapestry Request Cycle Begin
    servicer.service(request, response);
    // Tapestry Request Cycle End
    
    storeSharedSessionData();
    WepromRequestCycleUtil.close();
    
    LOG.debug("END");
  }

  private void storeSharedSessionData() {
    // Visit do not need to be aware of SharedSessionData, it could be stored using ApplicationStateManager.store(...)
    if (appStateManager.exists(VISIT_KEY)) {
      Visit visit = (Visit) appStateManager.get(VISIT_KEY);
      LOG.debug("SharedSessionData --> Visit");
      Object ssData = WepromRequestCycleUtil.currentSharedSessionData();
      visit.setSharedSessionData(ssData); 
    }
  }
  
  public void setAppStateManager(ApplicationStateManager asm) {
    appStateManager = asm;
  }  
}
