package com.nordija.tapestry.bayeux.downloads;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.hivemind.util.Defense;
import org.apache.tapestry.IComponent;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.StaleSessionException;
import org.apache.tapestry.engine.*;
import org.apache.tapestry.engine.state.ApplicationStateManager;
import org.apache.tapestry.services.LinkFactory;
import org.apache.tapestry.spec.IApplicationSpecification;
import org.apache.tapestry.services.ServiceConstants;
import org.apache.tapestry.web.WebRequest;
import org.apache.tapestry.web.WebSession;

public class DownloadService implements IEngineService {
  
  private static final Log LOG = LogFactory.getLog(com.nordija.tapestry.bayeux.downloads.DownloadService.class);
    
  private LinkFactory linkFactory;
  private ApplicationStateManager appStateManager;
  private WebRequest request;
  private IRequestCycle requestCycle;
  
  public static final String PATH = "path";
  public static final String SERVICE_NAME = "bayeux_downloads";
  
  public void setLinkFactory(LinkFactory linkFactory) {
    LOG.debug("setLinkFactory: " +linkFactory);
    this.linkFactory = linkFactory;
  } 
  
  public void setAppStateManager(ApplicationStateManager asm) {
    LOG.debug("setAppStateManager: " +asm);
    this.appStateManager = asm;
  } 

  public void setRequest(WebRequest request) {
    this.request = request;
  }

  /** @since 4.0 */
  public void setRequestCycle(IRequestCycle requestCycle) {
    this.requestCycle = requestCycle;
  }
  
/*
    public ILink getLink(IRequestCycle cycle, IComponent component, Object parameters[])
    {
        return constructLink(cycle, "bayeux.downloads", null, parameters, true);
    }
*/
  /*
    public void service(IEngineServiceView engine, IRequestCycle cycle, ResponseOutputStream out)
        throws ServletException, IOException
    {
        IApplicationSpecification specification = engine.getSpecification();
        DownloadResourceSource source = (DownloadResourceSource)specification.getExtension("bayeux.downloads.resourcesource", com.nordija.tapestry.bayeux.downloads.DownloadResourceSource.class);
        Object parameters[] = getParameters(cycle);
        String resourceId = null;
        if(parameters.length > 0)
            resourceId = (String)parameters[0];
        if(resourceId == null)
            throw new ServletException("unable to process download link, no resource id found");
        DownloadResource downloadResource = source.getDownloadResource(cycle, resourceId);
        if(downloadResource == null)
        {
            throw new ServletException("unable to process download link, no resource found on id: '" + resourceId + "'");
        } else
        {
            streamResource(resourceId, downloadResource, out);
            return;
        }
    }
*/
  /*
    private void streamResource(String resourceId, DownloadResource resource, ResponseOutputStream out)
        throws IOException
    {
        InputStream resourceInput;
        String contentType = resource.getContentType();
        out.setContentType(contentType);
        if(LOG.isDebugEnabled())
            LOG.debug("streaming resource '" + resourceId + "' with content-type '" + contentType + "'");
        resourceInput = null;
        resourceInput = resource.getInputStream();
        byte buf[] = new byte[1024];
        int bytesRead;
        while((bytesRead = resourceInput.read(buf)) != -1) 
            out.write(buf, 0, bytesRead);
        out.flush();
        if(resourceInput != null)
            resourceInput.close();
        break MISSING_BLOCK_LABEL_143;
        Exception exception;
        exception;
        if(resourceInput != null)
            resourceInput.close();
        throw exception;
    }
*/

    //////////////////////////////////////////////////////////////////////////////////////
    public String getName() {
      return SERVICE_NAME;
    }
    
    public ILink getLink(boolean post, Object parameter) {
      LOG.debug("getLink(post:"+post+"; parameter:"+parameter+")");
      Defense.isAssignable(parameter, String.class, "parameter");
      String path = (String) parameter;
      boolean stateful = request.getSession(false) != null;
      Map parameters = new HashMap();
      //parameters.put(ServiceConstants.SERVICE, SERVICE_NAME);
      parameters.put(ServiceConstants.SESSION, stateful ? "T" : null);
      parameters.put(PATH, path);
      return linkFactory.constructLink(this, post, parameters, true);      
    }

    public void service(IRequestCycle cycle) throws IOException {
      String _method = "service() "; 
      LOG.debug(_method);
      
      IApplicationSpecification specification = cycle.getEngine().getSpecification();
      DownloadResourceSource source = (DownloadResourceSource)specification.getExtension("bayeux.downloads.resourcesource", com.nordija.tapestry.bayeux.downloads.DownloadResourceSource.class);
      LOG.debug(_method + "source="+source);
      String resourceId = cycle.getParameter(PATH);
      boolean activeSession = cycle.getParameter(ServiceConstants.SESSION) != null;
      LOG.debug(_method + "resourceId="+resourceId+"; activeSession="+activeSession);
      
      if (activeSession) {
        WebSession session = request.getSession(false);
        LOG.debug(_method + "session="+session);
        if (session == null || session.isNew())
          throw new StaleSessionException();
      }
      /*
      Object parameters[] = getParameters(cycle);
      String resourceId = null;
      if(parameters.length > 0)
          resourceId = (String)parameters[0];
      if(resourceId == null)
          throw new ServletException("unable to process download link, no resource id found");
          */
      DownloadResource downloadResource = source.getDownloadResource(cycle, resourceId);
      if(downloadResource == null)
      {
          throw new IOException("unable to process download link, no resource found on id: '" + resourceId + "'");
      } else
      {
          streamResource(resourceId, downloadResource, cycle);
          return;
      } 
           
    }
    
    /////////////////////
    
    private void streamResource(String resourceId, DownloadResource resource, IRequestCycle cycle)
    throws IOException
{
      // TODO make it without the Servlet APIs .. only Tapestry lives here ;-) 
      HttpServletResponse response = cycle.getRequestContext().getResponse();
      ServletOutputStream out = response.getOutputStream();
      
    InputStream resourceInput;
    String contentType = resource.getContentType();
    String fileName = resource.getContentDisposition();
    response.setContentType(contentType);
    response.setHeader("Content-disposition", "inline; filename=" + fileName);
    if(LOG.isDebugEnabled())
        LOG.debug("streaming resource '" + resourceId + "' with content-type '" + contentType + "'");
    resourceInput = null;
    resourceInput = resource.getInputStream();
    byte buf[] = new byte[1024];
    int bytesRead;
    while((bytesRead = resourceInput.read(buf)) != -1) 
        out.write(buf, 0, bytesRead);
    out.flush();
    if(resourceInput != null)
        resourceInput.close();

    if(resourceInput != null)
        resourceInput.close();
    
}    
}
