package workspace.web;

import java.text.SimpleDateFormat;
import java.util.List;
import java.util.ArrayList;
import java.util.Date;
import java.io.Serializable;

import com.fmi.weprom.api.Reminder;

public class CalendarDay implements Serializable, Cloneable{
	private Date date;
	private List reminders;
	private boolean spam;
	
	public CalendarDay(Date dateVal, List remindersVal, boolean spamVal){
		this.reminders = remindersVal;
		this.spam= spamVal;
		this.date = dateVal;
	}	
	
	public CalendarDay(Date dateVal){
		this.reminders = new ArrayList();
		this.date = dateVal;
	}
	
	public Object clone() { 
	    try {
		  return (CalendarDay)super.clone(); 
	    } catch (CloneNotSupportedException e) {
	         throw new InternalError("But we are Cloneable!!!");
	    }
	}

	public Date getDate() {
		return date;
	}
	public void setDate(Date dateVal) {
		this.date = dateVal;
	}
	public boolean getSpam() {
		return spam;
	}
	public void setSpam(boolean spamVal) {
		this.spam = spamVal;
	}
	public List getReminders() {
		return reminders;
	}
	public void setReminders(List remindersVal) {
		this.reminders = remindersVal;
	}
	public boolean hasReminders(){
		return this.reminders.size()>0;
	}
	public void addReminder(Reminder reminder) {
		this.reminders.add(reminder);
	}
	public String getDisplayId() {
		String day="";
		if(this.date!=null & !this.spam){
			SimpleDateFormat formatter = new SimpleDateFormat("dd");
			day = formatter.format(this.date);
        }
		return day;
	}
	public String getRemNmbr() {
		return "" + this.reminders.size();
	}
	public String[] getDisplayIdLong() {
		SimpleDateFormat formatter = new SimpleDateFormat("dd/MM/yy");
        String day = formatter.format(this.date);
		String[] longDispId = {day, "" + this.reminders.size()};
        return longDispId;
	}	
}
