package workspace.web;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.Date;
import java.util.List;
import java.io.Serializable;


import com.fmi.weprom.api.Reminder;
import com.fmi.weprom.api.UserWorkspace;
import com.fmi.weprom.api.Project;
import com.fmi.weprom.api.Community;

public class CalendarMonth implements Serializable {
	
  private int day;
  private int month;
  private int year;
	CalendarDay[][]calendarDayList;
	
	final static int daysOfWeek[] = {Calendar.SUNDAY, Calendar.MONDAY, Calendar.TUESDAY, 
		Calendar.WEDNESDAY, Calendar.THURSDAY, Calendar.FRIDAY, Calendar.SATURDAY};
	
  public CalendarMonth() {
  }
  
  public CalendarMonth(Object currUserWorkspace, int year, int month, int date) {
    this.day = date;
    this.month = month;
    this.year = year;
    this.calendarDayList = buildCalendarDayList(currUserWorkspace, year, month, date);	
  }
  
  public int getYear() {
    return year;
  }

  public int getMonth() {
    return month;
  }
	
  public CalendarDay updateDay(Object curr, CalendarDay day){
		if(day!=null){
			System.out.println("Update Calendar Day : " + day.getDate());
			int nmbrWeeks = calendarDayList[0].length;
			for(int j=0; j<nmbrWeeks; j++){
				for(int i=0; i<7; i++){ 
					if(DateComparator.areDatesEqual(calendarDayList[i][j].getDate(), day.getDate())){
						List reminders = new ArrayList();
            System.out.println("Dates are equal!: " + day.getDate());
            GregorianCalendar dt = DateComparator.createGregCalendarForDate(day.getDate());
            dt.set(Calendar.HOUR_OF_DAY, 0);
            dt.set(Calendar.MINUTE, 0);
            dt.set(Calendar.SECOND, 0);
            Date startDate = dt.getTime();
            dt.set(Calendar.HOUR_OF_DAY, 23);
            dt.set(Calendar.MINUTE, 59);
            dt.set(Calendar.SECOND, 59);
            Date endDate = dt.getTime();
					if(curr instanceof UserWorkspace){
						reminders = ((UserWorkspace)curr).getCalendar().getReminders(startDate, endDate);
            System.out.println("Reminders number : " + reminders.size());
            for(int k = 0; k< reminders.size(); k++)
              System.out.println("Reminder : " + (Reminder)reminders.get(k));
          }
          else if(curr instanceof Project)
            reminders = ((Project)curr).getCalendar().getReminders(startDate, endDate);             
          else if(curr instanceof Community)
            reminders = ((Community)curr).getCalendar().getReminders(startDate, endDate);
          
					day.setReminders(reminders);
					calendarDayList[i][j]=day;
					return day;
					}
				}
			}
			return null;
		}else
			return null;
	}
	  
  public CalendarDay updateDay(Object curr, Date date){
    int nmbrWeeks = calendarDayList[0].length;
    for(int j=0; j<nmbrWeeks; j++){
      for(int i=0; i<7; i++){ 
        if(DateComparator.areDatesEqual(calendarDayList[i][j].getDate(), date)){          
          List reminders = new ArrayList();
          GregorianCalendar dt = DateComparator.createGregCalendarForDate(date);
          dt.set(Calendar.HOUR_OF_DAY, 0);
          dt.set(Calendar.MINUTE, 0);
          dt.set(Calendar.SECOND, 0);
          Date startDate = dt.getTime();
          dt.set(Calendar.HOUR_OF_DAY, 23);
          dt.set(Calendar.MINUTE, 59);
          dt.set(Calendar.SECOND, 59);
          Date endDate = dt.getTime();
          if(curr instanceof UserWorkspace)
            reminders = ((UserWorkspace)curr).getCalendar().getReminders(startDate, endDate);
          else if(curr instanceof Project)
            reminders = ((Project)curr).getCalendar().getReminders(startDate, endDate);             
          else if(curr instanceof Community)
            reminders = ((Community)curr).getCalendar().getReminders(startDate, endDate);
          CalendarDay day = new CalendarDay(date, reminders, false);          
          calendarDayList[i][j]=day;
          return day;
        }
      }
    }
    return null;
  }
  
  public CalendarDay print(){
    int nmbrWeeks = calendarDayList[0].length;
    for(int j=0; j<nmbrWeeks; j++){
      for(int i=0; i<7; i++){ 
        System.out.println("day: " + calendarDayList[i][j].getDate()+
            " spam: " +  calendarDayList[i][j].getSpam()+
            " nmbrRem: " +  calendarDayList[i][j].getRemNmbr());
      }
    }
    return null;
  }
  	
  public CalendarDay getDay(Date date){
		int nmbrWeeks = calendarDayList[0].length;
		for(int j=0; j<nmbrWeeks; j++){
			for(int i=0; i<7; i++){ 
				if(DateComparator.areDatesEqual(calendarDayList[i][j].getDate(), date))					
					return calendarDayList[i][j];				
			}
		}
		return null;
	}

  public CalendarDay[][] getCalendarDayList(){
    return calendarDayList;
  } 
  
  public CalendarDay[][] getCalendarDayList(Object currUserWorkspace, int year, int month, int date){
    if(year != this.year || month != this.month || calendarDayList == null){
      this.day = date;
      this.month = month;
      this.year = year;
      this.calendarDayList = buildCalendarDayList(currUserWorkspace, year, month, date);
    }
    return calendarDayList;
  } 

  private CalendarDay[][] buildCalendarDayList(Object currUserWorkspace, int year, int month, int date){
    // Initialize work lists and Calendar
    List reminders = new ArrayList(); // holds the user's reminders for the current month
    CalendarDay[][] calendarByWeeks = new CalendarDay[7][6]; // display list with the reminders
    CalendarDay[][] calendarByWeeks1 = new CalendarDay[1][1];
    Calendar init = new GregorianCalendar(year, month, date);

    // According to the current time, define a period of 1 month, 
    Calendar c = new GregorianCalendar(year, month, date);
    c.setLenient(true);
    
    // Beginning of current month
    int firstYearToDisplay = c.get(Calendar.YEAR);
    int firstMonthToDisplay = c.get(Calendar.MONTH);
    int firstDayToDisplay = 1;    
    c.set(Calendar.DAY_OF_MONTH, firstDayToDisplay);
    
    // End of displayed period
    c.add(Calendar.MONTH, 1);
    c.add(Calendar.DAY_OF_MONTH, -1);
    c.set(Calendar.DAY_OF_WEEK, daysOfWeek[6]);
    int lastYearToDisplay = c.get(Calendar.YEAR);
    int lastMonthToDisplay = c.get(Calendar.MONTH);     
    int lastDayToDisplay = c.get(Calendar.DAY_OF_MONTH);      
    Calendar end = new GregorianCalendar(lastYearToDisplay, lastMonthToDisplay, lastDayToDisplay, 23, 59, 59);
    
    // Beginning of displayed period
    c.set(firstYearToDisplay, firstMonthToDisplay, firstDayToDisplay);
    c.set(Calendar.WEEK_OF_MONTH, 1);
    c.set(Calendar.DAY_OF_WEEK, daysOfWeek[0]); // set the day to the 1st day of the 1st week to be displayed
    
    // Display the period limits in the output 
    System.out.println("Start Period : " + c.get(Calendar.DAY_OF_MONTH) +
        "/" + (c.get(Calendar.MONTH)+1) + "/" + c.get(Calendar.YEAR));
    System.out.println("End Period : " + end.get(Calendar.DAY_OF_MONTH) +
        "/" + (end.get(Calendar.MONTH)+1) + "/" + end.get(Calendar.YEAR));
    
    // Get the user's reminders for the defined period
    if(currUserWorkspace instanceof UserWorkspace)
      reminders = ((UserWorkspace)currUserWorkspace).getCalendar().getReminders(c.getTime(), end.getTime());
    else if(currUserWorkspace instanceof Project)
      reminders = ((Project)currUserWorkspace).getCalendar().getReminders(c.getTime(), end.getTime());             
    else if(currUserWorkspace instanceof Community)
      reminders = ((Community)currUserWorkspace).getCalendar().getReminders(c.getTime(), end.getTime());             
    
    for(int weekOnPage=0; weekOnPage<6; weekOnPage++){
      for(int dayInWeek=0; dayInWeek<7; dayInWeek++){ 
        List dayReminders = new ArrayList(); // new list to hold the reminders of the curr day
        // If there are reminders with date equal to the curr day, 
        // add them to list of day reminders          
        for(int k=0;k<reminders.size();k++){            
          Reminder reminder = (Reminder)reminders.get(k);
          Calendar a = GregorianCalendar.getInstance();
          a.setTime(reminder.getDate());
          
          if(a.get(Calendar.YEAR)==c.get(Calendar.YEAR)&
              a.get(Calendar.DAY_OF_YEAR)==c.get(Calendar.DAY_OF_YEAR))
            dayReminders.add(reminder);               
        }
        // Create a new CalendarDay
        CalendarDay day = new CalendarDay(c.getTime(), dayReminders, false);
        // If it doesn't belong to the current month, set spam=true
        if(init.get(Calendar.MONTH)!=c.get(Calendar.MONTH))
          day.setSpam(true);
          
        // Add the day to the diplay list, and increment the calendar with 1 day
        calendarByWeeks[dayInWeek][weekOnPage] = day;
        c.add(Calendar.DAY_OF_YEAR, 1);
      }
      
      // If the period has ended and the weeks displayed are less than 6, 
      // create a new display list with fixed weeks' number
      int dayOfMonth = c.get(Calendar.DAY_OF_MONTH);
      if(dayOfMonth>=1 & dayOfMonth<=7 & weekOnPage!=0){          
        calendarByWeeks1 = new CalendarDay[7][weekOnPage+1]; // display list with the reminders
        for(int weekOnPage1=0; weekOnPage1<weekOnPage+1; weekOnPage1++)
          for(int dayInWeek=0; dayInWeek<7; dayInWeek++) 
            calendarByWeeks1[dayInWeek][weekOnPage1] = calendarByWeeks[dayInWeek][weekOnPage1];
        weekOnPage = 7;   
      }       
    } 
    return calendarByWeeks1;
  } 

}
