package workspace.web.components.docsbrowser;

import org.apache.tapestry.IRender;
import org.apache.tapestry.IRequestCycle;
import org.apache.tapestry.contrib.tree.components.INodeRenderFactory;
import org.apache.tapestry.contrib.tree.model.ITreeDataModel;
import org.apache.tapestry.contrib.tree.model.ITreeModelSource;
import org.apache.tapestry.contrib.tree.model.ITreeStateModel;
import org.apache.tapestry.valid.RenderString;

public class NodeRenderFactory implements INodeRenderFactory {

  public IRender getRenderByID(Object objUniqueKey, ITreeModelSource treeModelSource, IRequestCycle cycle) {
    Object node = treeModelSource.getTreeModel().getTreeDataModel().getObject(objUniqueKey);
    return new NodeRender((FileNode) node, objUniqueKey, treeModelSource);
  }

  public IRender getRender(Object node, ITreeModelSource treeModelSource, IRequestCycle cycle) {
    ITreeDataModel dataModel = treeModelSource.getTreeModel().getTreeDataModel();
    Object nodeKey = dataModel.getUniqueKey(node, null);
    return new NodeRender((FileNode) node, nodeKey, treeModelSource);
  }

}
