package workspace.web.pages;

import java.util.List;

import org.apache.tapestry.event.PageRenderListener;
import org.apache.tapestry.html.BasePage;
import org.apache.tapestry.event.PageEvent;

import workspace.Visit;
import workspace.web.CalendarDay;


public abstract class CalendarDayListPage extends WEPROMBasePage  implements PageRenderListener {
	
	public abstract CalendarDay getDay();
	public abstract void setDay(CalendarDay calendarDay);
	public abstract void setCalendarDayList(List calendarDayList);
	public abstract boolean getIsAnotherDay();
	public abstract void setIsAnotherDay(boolean isAnotherDay);
	public abstract void setPageType(String pageType);
	
	public void pageBeginRender(PageEvent event){
    	System.out.println("CalendarDayListPage: pageBeginRender: >--->" );
		setPageType(determinPageType());
		if(!event.getRequestCycle().isRewinding()){
			CalendarDay day = getDay();			
			if (day==null) {
				setCalendarDayList(((Visit) getPage().getVisit()).getReminders());
			} else 
				if(getIsAnotherDay()){
					setCalendarDayList(getDay().getReminders());	
					System.out.println("CalendarDayListPage: " + getIsAnotherDay() );
					setIsAnotherDay(false);
				} 			
		}
	}
	private String determinPageType(){
    if (((Visit) getPage().getVisit()).getProject()!=null)
      return "Projects";
    else if (((Visit) getPage().getVisit()).getCommunity()!=null)
      return"Communities";
    else
      return "MyWorkspace";
  }
}
