package workspace.web.pages;

import java.util.List;
import java.util.ArrayList;

import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.event.PageRenderListener;
import org.apache.tapestry.html.BasePage;

import com.fmi.weprom.api.Message;

import workspace.MessageUtil;
import workspace.Visit;
import workspace.web.components.MessageEditor;

public abstract class MessageCreatorPage extends WEPROMBasePage implements PageRenderListener{
  
  public abstract Message getMessage();
  public abstract void setMessage(Message message);
  public abstract int getMode();
  public abstract void setMode(int mode);
	public abstract void setReceiverString(String receiverString);
	public abstract void setPageType(String pageType);
  public abstract List getReceiverList();
  public abstract void setReceiverList(List receiverList);
  public static final int MODE_CREATE = 2;

  
	public void pageBeginRender(PageEvent event) {    
		System.out.println("MessageCreatorPage() ... isRewinding=" + event.getRequestCycle().isRewinding());
		setPageType(determinPageType());
		if(!event.getRequestCycle().isRewinding()){
			Message message = getMessage();
			int mode = getMode();
	    	System.out.println("MessageCreatorPage: Mode1 = "+getMode() );
			// If the page is rendering in create mode and the message is null,
			// create a new message with sender = current user			
			if (message==null & mode!=0) {
        message = MessageUtil.createMessage(((Visit) getVisit()).getUser(), Message.MESSAGE_TYPE_TEXT);
        setReceiverString("");
        setReceiverList(new ArrayList());
        MessageEditor messageEditor = (MessageEditor)getComponent("messageEditor");
        messageEditor.setWorkspaceTypeFilter(null);
				setMessage(message);
				setMode(MODE_CREATE);
		    System.out.println("MessageCreatorPage: Mode2 = "+getMode() );
			}
		}
	}
	private String determinPageType(){
		if (((Visit) getPage().getVisit()).getProject()==null)
			return"MyWorkspace";
		else
			return "Projects";
	}  
}
