package workspace.web.pages;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.ArrayList;

import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.event.PageRenderListener;
import org.apache.tapestry.html.BasePage;

import workspace.Visit;
import workspace.web.CalendarDay;

import com.fmi.weprom.api.Reminder;

public abstract class ReminderCreatorPage extends WEPROMBasePage implements
    PageRenderListener {
  public static final int MODE_CREATE = 2;

  public abstract Reminder getReminder();
  public abstract void setReminder(Reminder reminder);

  public abstract int getMode();
  public abstract void setMode(int mode);

  public abstract String getTime();
  public abstract void setTime(String time);

  public abstract void setCalendarDay(CalendarDay day);

  public abstract void setPageType(String pageType);

  public void pageBeginRender(PageEvent event) {
    System.out.println("ReminderCreatorPage() ... isRewinding="
        + event.getRequestCycle().isRewinding());
    setPageType(determinPageType());
    if (!event.getRequestCycle().isRewinding()) {
      Reminder reminder = getReminder();
      int mode = getMode();
      if (reminder == null & mode != 0) {
        reminder = ((Visit) getPage().getVisit()).getCalendar().createReminder();
        if(reminder!=null){
          List reminders = new ArrayList();
          reminders.add(reminder);
          setReminder(reminder);
          reminder.setDate(new Date());
          setMode(MODE_CREATE);
          setTime(getTime(reminder));
          setCalendarDay(new CalendarDay(new Date(), reminders, false));
        }
      }
    }
  }

  public String getTime(Reminder reminder) {
    SimpleDateFormat formatter = new SimpleDateFormat("HH:mm");
    if(reminder.getDate() != null)
      return formatter.format(reminder.getDate());
    else
      return "00:00";
  }

  private String determinPageType(){
    if (((Visit) getPage().getVisit()).getProject()!=null)
      return "Projects";
    else if (((Visit) getPage().getVisit()).getCommunity()!=null)
      return"Communities";
    else
      return "MyWorkspace";
  }
}
