package workspace.web.pages;

import org.apache.tapestry.event.PageEvent;
import org.apache.tapestry.event.PageRenderListener;
import org.apache.tapestry.html.BasePage;

import com.fmi.weprom.api.User;

import workspace.Visit;

public abstract class UserEditorPage extends WEPROMBasePage implements PageRenderListener {
  public abstract User getUser();
  public abstract void setUser(User user);
  public abstract int getMode();
  public abstract void setMode(int mode);
  public abstract void setPageType(String pageType);
    
	public void pageBeginRender(PageEvent event) {    
		System.out.println("UserEditorPage() ... isRewinding=" + event.getRequestCycle().isRewinding());
    setPageType(determinPageType());
		if(!event.getRequestCycle().isRewinding()){
			User user = getUser();
			int mode = getMode();
	    System.out.println("User: Mode = " + mode );
			if (user==null & mode!=0) {				
				user = ((Visit)getPage().getVisit()).getWeprom().createUser("user");;				
				setUser(user);				
			}
		}
	}
  
  private String determinPageType(){
    if (((Visit) getPage().getVisit()).getProject()!=null)
      return "Projects";
    else if (((Visit) getPage().getVisit()).getCommunity()!=null)
      return "Communities";
    else
      return "MyWorkspace";
  }
}

